// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: service_account.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	ServiceAccounts_GetServiceAccountByID_FullMethodName = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/GetServiceAccountByID"
	ServiceAccounts_GetServiceAccounts_FullMethodName    = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/GetServiceAccounts"
	ServiceAccounts_CreateServiceAccount_FullMethodName  = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/CreateServiceAccount"
	ServiceAccounts_UpdateServiceAccount_FullMethodName  = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/UpdateServiceAccount"
	ServiceAccounts_DeleteServiceAccount_FullMethodName  = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/DeleteServiceAccount"
	ServiceAccounts_CreateToken_FullMethodName           = "/martiancloud.phobos.api.serviceaccount.ServiceAccounts/CreateToken"
)

// ServiceAccountsClient is the client API for ServiceAccounts service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// ServiceAccounts implements all functionalities related to service accounts.
type ServiceAccountsClient interface {
	// GetServiceAccountByID returns a service account by its ID.
	GetServiceAccountByID(ctx context.Context, in *GetServiceAccountByIDRequest, opts ...grpc.CallOption) (*ServiceAccount, error)
	// GetServiceAccounts returns a list of service accounts.
	GetServiceAccounts(ctx context.Context, in *GetServiceAccountsRequest, opts ...grpc.CallOption) (*GetServiceAccountsResponse, error)
	// CreateServiceAccount creates a new service account.
	CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, opts ...grpc.CallOption) (*ServiceAccount, error)
	// UpdateServiceAccount updates an existing service account.
	UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, opts ...grpc.CallOption) (*ServiceAccount, error)
	// DeleteServiceAccount deletes an existing service account.
	DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// CreateToken creates a new token for a service account using an existing
	// token.
	CreateToken(ctx context.Context, in *CreateTokenRequest, opts ...grpc.CallOption) (*CreateTokenResponse, error)
}

type serviceAccountsClient struct {
	cc grpc.ClientConnInterface
}

func NewServiceAccountsClient(cc grpc.ClientConnInterface) ServiceAccountsClient {
	return &serviceAccountsClient{cc}
}

func (c *serviceAccountsClient) GetServiceAccountByID(ctx context.Context, in *GetServiceAccountByIDRequest, opts ...grpc.CallOption) (*ServiceAccount, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ServiceAccount)
	err := c.cc.Invoke(ctx, ServiceAccounts_GetServiceAccountByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountsClient) GetServiceAccounts(ctx context.Context, in *GetServiceAccountsRequest, opts ...grpc.CallOption) (*GetServiceAccountsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetServiceAccountsResponse)
	err := c.cc.Invoke(ctx, ServiceAccounts_GetServiceAccounts_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountsClient) CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, opts ...grpc.CallOption) (*ServiceAccount, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ServiceAccount)
	err := c.cc.Invoke(ctx, ServiceAccounts_CreateServiceAccount_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountsClient) UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, opts ...grpc.CallOption) (*ServiceAccount, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ServiceAccount)
	err := c.cc.Invoke(ctx, ServiceAccounts_UpdateServiceAccount_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountsClient) DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ServiceAccounts_DeleteServiceAccount_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountsClient) CreateToken(ctx context.Context, in *CreateTokenRequest, opts ...grpc.CallOption) (*CreateTokenResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CreateTokenResponse)
	err := c.cc.Invoke(ctx, ServiceAccounts_CreateToken_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ServiceAccountsServer is the server API for ServiceAccounts service.
// All implementations must embed UnimplementedServiceAccountsServer
// for forward compatibility.
//
// ServiceAccounts implements all functionalities related to service accounts.
type ServiceAccountsServer interface {
	// GetServiceAccountByID returns a service account by its ID.
	GetServiceAccountByID(context.Context, *GetServiceAccountByIDRequest) (*ServiceAccount, error)
	// GetServiceAccounts returns a list of service accounts.
	GetServiceAccounts(context.Context, *GetServiceAccountsRequest) (*GetServiceAccountsResponse, error)
	// CreateServiceAccount creates a new service account.
	CreateServiceAccount(context.Context, *CreateServiceAccountRequest) (*ServiceAccount, error)
	// UpdateServiceAccount updates an existing service account.
	UpdateServiceAccount(context.Context, *UpdateServiceAccountRequest) (*ServiceAccount, error)
	// DeleteServiceAccount deletes an existing service account.
	DeleteServiceAccount(context.Context, *DeleteServiceAccountRequest) (*emptypb.Empty, error)
	// CreateToken creates a new token for a service account using an existing
	// token.
	CreateToken(context.Context, *CreateTokenRequest) (*CreateTokenResponse, error)
	mustEmbedUnimplementedServiceAccountsServer()
}

// UnimplementedServiceAccountsServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedServiceAccountsServer struct{}

func (UnimplementedServiceAccountsServer) GetServiceAccountByID(context.Context, *GetServiceAccountByIDRequest) (*ServiceAccount, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetServiceAccountByID not implemented")
}
func (UnimplementedServiceAccountsServer) GetServiceAccounts(context.Context, *GetServiceAccountsRequest) (*GetServiceAccountsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetServiceAccounts not implemented")
}
func (UnimplementedServiceAccountsServer) CreateServiceAccount(context.Context, *CreateServiceAccountRequest) (*ServiceAccount, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateServiceAccount not implemented")
}
func (UnimplementedServiceAccountsServer) UpdateServiceAccount(context.Context, *UpdateServiceAccountRequest) (*ServiceAccount, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateServiceAccount not implemented")
}
func (UnimplementedServiceAccountsServer) DeleteServiceAccount(context.Context, *DeleteServiceAccountRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteServiceAccount not implemented")
}
func (UnimplementedServiceAccountsServer) CreateToken(context.Context, *CreateTokenRequest) (*CreateTokenResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateToken not implemented")
}
func (UnimplementedServiceAccountsServer) mustEmbedUnimplementedServiceAccountsServer() {}
func (UnimplementedServiceAccountsServer) testEmbeddedByValue()                         {}

// UnsafeServiceAccountsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ServiceAccountsServer will
// result in compilation errors.
type UnsafeServiceAccountsServer interface {
	mustEmbedUnimplementedServiceAccountsServer()
}

func RegisterServiceAccountsServer(s grpc.ServiceRegistrar, srv ServiceAccountsServer) {
	// If the following call pancis, it indicates UnimplementedServiceAccountsServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&ServiceAccounts_ServiceDesc, srv)
}

func _ServiceAccounts_GetServiceAccountByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetServiceAccountByIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).GetServiceAccountByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_GetServiceAccountByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).GetServiceAccountByID(ctx, req.(*GetServiceAccountByIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ServiceAccounts_GetServiceAccounts_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetServiceAccountsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).GetServiceAccounts(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_GetServiceAccounts_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).GetServiceAccounts(ctx, req.(*GetServiceAccountsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ServiceAccounts_CreateServiceAccount_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateServiceAccountRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).CreateServiceAccount(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_CreateServiceAccount_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).CreateServiceAccount(ctx, req.(*CreateServiceAccountRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ServiceAccounts_UpdateServiceAccount_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateServiceAccountRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).UpdateServiceAccount(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_UpdateServiceAccount_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).UpdateServiceAccount(ctx, req.(*UpdateServiceAccountRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ServiceAccounts_DeleteServiceAccount_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteServiceAccountRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).DeleteServiceAccount(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_DeleteServiceAccount_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).DeleteServiceAccount(ctx, req.(*DeleteServiceAccountRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ServiceAccounts_CreateToken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateTokenRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ServiceAccountsServer).CreateToken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ServiceAccounts_CreateToken_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ServiceAccountsServer).CreateToken(ctx, req.(*CreateTokenRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ServiceAccounts_ServiceDesc is the grpc.ServiceDesc for ServiceAccounts service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ServiceAccounts_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.serviceaccount.ServiceAccounts",
	HandlerType: (*ServiceAccountsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetServiceAccountByID",
			Handler:    _ServiceAccounts_GetServiceAccountByID_Handler,
		},
		{
			MethodName: "GetServiceAccounts",
			Handler:    _ServiceAccounts_GetServiceAccounts_Handler,
		},
		{
			MethodName: "CreateServiceAccount",
			Handler:    _ServiceAccounts_CreateServiceAccount_Handler,
		},
		{
			MethodName: "UpdateServiceAccount",
			Handler:    _ServiceAccounts_UpdateServiceAccount_Handler,
		},
		{
			MethodName: "DeleteServiceAccount",
			Handler:    _ServiceAccounts_DeleteServiceAccount_Handler,
		},
		{
			MethodName: "CreateToken",
			Handler:    _ServiceAccounts_CreateToken_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "service_account.proto",
}
